package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class HistoricoRequisicaoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaHistoricoRequisicao = By.xpath("//span[text() = 'Histórico de Requisição']");

    By campoRelatorio = By.xpath("//div[@data-zh-id=\"2238065432892371645549\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By relatorioAnaliticoPorData = By.xpath("//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Histórico de Requisição (Analítico por Data)']");
    By relatorioSinteticoPorData = By.xpath("//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Histórico de Requisição (Sintético por Data)']");
    By relatorioSinteticoPorOperador = By.xpath("//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Histórico de Requisição (Sintético por Operador)']");
    By relatorioAnaliticoPorOperador = By.xpath("//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Histórico de Requisição (Analítico por Operador)']");

    By campoUnidade = By.id("NMFILIAL");
    By unidadeJabaquara = By.xpath("//div[@data-zh-id=\"2238065414020094425551\"]//span[text() = '0002 | DEPOSITO JABAQUARA']");
    By botaoCampoUnidade = By.xpath("//div[@id=\"NMFILIAL\"]//span[@style=\"background-image: none; display: block;\"]");

    By botaoCampoData = By.xpath("//div[@id=\"DTINTERVAL\"]//span[@zh-icon=\"no-border close-x\"]");
    By campoDataInicial = By.id("DTINTERVAL_START");
    By campoDataFinal = By.id("DTINTERVAL_END");

    By todosOperadores = By.xpath("//label[@for='zh-checkbox-TODOSOPER']//div[@class='zh-box mousetrap zh-ripple-effect']");
    By campoOperador = By.id("NMOPERADOR");
    By operadorThiagoBento = By.xpath("//div[@data-zh-field-name='NMOPERADOR']//span[text() = 'Thiago Automação']");
    By operadoraCarlaRotondo = By.xpath("//div[@data-zh-field-name='NMOPERADOR']//span[text() = 'Carla Automação']");
    By operadorGustavoFigueiredo = By.xpath("//div[@data-zh-field-name='NMOPERADOR']//span[text() = 'Gustavo Figueiredo']");

    By todosServicos = By.xpath("//div[@data-zh-id='2238065420150836665567']//div[@class='zh-box mousetrap zh-ripple-effect']");
    By campoServico = By.id("NMSERVICO");
    By servicoRetiradas = By.xpath("//div[@data-zh-field-name='NMSERVICO']//span[text() = 'RETIRADAS']");
    By servicoAlmocoEspecial = By.xpath("//div[@data-zh-field-name='NMSERVICO']//span[text() = 'ALMOÇO ESPECIAL']");

    By botaoOk = By.xpath("//section[@class='popup-container']//div[@class='zh-footer-right']");

    By botaoRelatorio = By.xpath("//div[@class='zh-footer-right']");
    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@class='zh-inner-circle']");
    By botaoConfirmar = By.xpath("//section[@id='popup']//div[@class='zh-footer-right']//span[text() = 'Confirmar']");

    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"2238065414020094425551\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioData = By.xpath("//div[@data-zh-id=\"2238065440538505525555\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioOperador = By.xpath("//div[@data-zh-id=\"223806543790684105557\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"2238065438437033445563\"]//div[@class=\"zh-validation\"]/span");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Histórico de Requisição");
        click(telaHistoricoRequisicao);
    }

    public void preencherDatas(String dataInicial, String dataFinal) {
        super.preencherDatas(campoDataInicial, campoDataFinal, dataInicial, dataFinal);
    }

    public void selecionaRelatorio(String nomeRelatorio) {
        if(nomeRelatorio == "Histórico de Requisição (Analítico por Data)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioAnaliticoPorData);
        } else if(nomeRelatorio == "Histórico de Requisição (Sintético por Data)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioSinteticoPorData);
        } else if(nomeRelatorio == "Histórico de Requisição (Sintético por Operador)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioSinteticoPorOperador);
        } else if(nomeRelatorio == "Histórico de Requisição (Analítico por Operador)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioAnaliticoPorOperador);
        }
    }

    public void selecionarUnidadeJabaquara() {
        clicarCampoSelecionarValor(campoUnidade, unidadeJabaquara);
    }

    public void selecionarAlgunsOperadores() {
        click(todosOperadores);
        click(campoOperador);
        click(operadoraCarlaRotondo);
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-9999 > div.grid-vertical-scroll-control\").scrollBy(0, 200)");
        click(operadorThiagoBento);
        click(operadorGustavoFigueiredo);
        click(botaoOk);
    }

    public void selecionarServicos() {
        click(todosServicos);
        click(campoServico);
        click(servicoRetiradas);
        click(servicoAlmocoEspecial);
        click(botaoOk);
    }

    public void geraRelatorio() {
        super.geraRelatorio(botaoRelatorio, tipoPdf, botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

    public void camposObrigatorios() {
        click(botaoCampoUnidade);
        click(todosOperadores);
        click(todosServicos);
        click(botaoRelatorio);

        //mensagem encontradas nos campos obrigatórios
        String unidade = getText(mensagemObrigatorioUnidade);
        String data = getText(mensagemObrigatorioData);
        String operador = getText(mensagemObrigatorioOperador);
        String servico = getText(mensagemObrigatorioServico);

        String mensagemEsperada = "Campo obrigatório";
        String mensagemEsperadaData = "Campo obrigatório!";
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'unidade'");
        Assert.assertEquals(data, mensagemEsperadaData, "Verificação da mensagem de campo obrigatório no campo 'data'");
        Assert.assertEquals(operador, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'operador'");
        Assert.assertEquals(servico, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'serviço'");
    }

}
